/// @cond EO_CXX_EO_IMPL

inline bool elm::clock::show_am_pm_get() const
{
   Eina_Bool _tmp_ret;
   eo_do(_concrete_eo_ptr(), _tmp_ret = ::elm_obj_clock_show_am_pm_get());
   return ::efl::eolian::to_cxx<bool>(_tmp_ret, std::tuple<std::false_type>());
}

inline void elm::clock::show_am_pm_set(bool am_pm_) const
{
   eo_do(_concrete_eo_ptr(), ::elm_obj_clock_show_am_pm_set(::efl::eolian::to_c(am_pm_)));
}

inline double elm::clock::first_interval_get() const
{
   double _tmp_ret;
   eo_do(_concrete_eo_ptr(), _tmp_ret = ::elm_obj_clock_first_interval_get());
   return _tmp_ret;
}

inline void elm::clock::first_interval_set(double interval_) const
{
   eo_do(_concrete_eo_ptr(), ::elm_obj_clock_first_interval_set(interval_));
}

inline bool elm::clock::show_seconds_get() const
{
   Eina_Bool _tmp_ret;
   eo_do(_concrete_eo_ptr(), _tmp_ret = ::elm_obj_clock_show_seconds_get());
   return ::efl::eolian::to_cxx<bool>(_tmp_ret, std::tuple<std::false_type>());
}

inline void elm::clock::show_seconds_set(bool seconds_) const
{
   eo_do(_concrete_eo_ptr(), ::elm_obj_clock_show_seconds_set(::efl::eolian::to_c(seconds_)));
}

inline bool elm::clock::edit_get() const
{
   Eina_Bool _tmp_ret;
   eo_do(_concrete_eo_ptr(), _tmp_ret = ::elm_obj_clock_edit_get());
   return ::efl::eolian::to_cxx<bool>(_tmp_ret, std::tuple<std::false_type>());
}

inline void elm::clock::edit_set(bool edit_) const
{
   eo_do(_concrete_eo_ptr(), ::elm_obj_clock_edit_set(::efl::eolian::to_c(edit_)));
}

inline bool elm::clock::pause_get() const
{
   Eina_Bool _tmp_ret;
   eo_do(_concrete_eo_ptr(), _tmp_ret = ::elm_obj_clock_pause_get());
   return ::efl::eolian::to_cxx<bool>(_tmp_ret, std::tuple<std::false_type>());
}

inline void elm::clock::pause_set(bool paused_) const
{
   eo_do(_concrete_eo_ptr(), ::elm_obj_clock_pause_set(::efl::eolian::to_c(paused_)));
}

inline void elm::clock::time_get(int* hrs_, int* min_, int* sec_) const
{
   eo_do(_concrete_eo_ptr(), ::elm_obj_clock_time_get(hrs_, min_, sec_));
}

inline void elm::clock::time_set(int hrs_, int min_, int sec_) const
{
   eo_do(_concrete_eo_ptr(), ::elm_obj_clock_time_set(hrs_, min_, sec_));
}

inline Elm_Clock_Edit_Mode elm::clock::edit_mode_get() const
{
   Elm_Clock_Edit_Mode _tmp_ret;
   eo_do(_concrete_eo_ptr(), _tmp_ret = ::elm_obj_clock_edit_mode_get());
   return _tmp_ret;
}

inline void elm::clock::edit_mode_set(Elm_Clock_Edit_Mode digedit_) const
{
   eo_do(_concrete_eo_ptr(), ::elm_obj_clock_edit_mode_set(digedit_));
}

inline bool eo_cxx::elm::clock::show_am_pm_get() const
{
   Eina_Bool _tmp_ret;
   eo_do(_concrete_eo_ptr(), _tmp_ret = ::elm_obj_clock_show_am_pm_get());
   return ::efl::eolian::to_cxx<bool>(_tmp_ret, std::tuple<std::false_type>());
}

inline void eo_cxx::elm::clock::show_am_pm_set(bool am_pm_) const
{
   eo_do(_concrete_eo_ptr(), ::elm_obj_clock_show_am_pm_set(::efl::eolian::to_c(am_pm_)));
}

inline double eo_cxx::elm::clock::first_interval_get() const
{
   double _tmp_ret;
   eo_do(_concrete_eo_ptr(), _tmp_ret = ::elm_obj_clock_first_interval_get());
   return _tmp_ret;
}

inline void eo_cxx::elm::clock::first_interval_set(double interval_) const
{
   eo_do(_concrete_eo_ptr(), ::elm_obj_clock_first_interval_set(interval_));
}

inline bool eo_cxx::elm::clock::show_seconds_get() const
{
   Eina_Bool _tmp_ret;
   eo_do(_concrete_eo_ptr(), _tmp_ret = ::elm_obj_clock_show_seconds_get());
   return ::efl::eolian::to_cxx<bool>(_tmp_ret, std::tuple<std::false_type>());
}

inline void eo_cxx::elm::clock::show_seconds_set(bool seconds_) const
{
   eo_do(_concrete_eo_ptr(), ::elm_obj_clock_show_seconds_set(::efl::eolian::to_c(seconds_)));
}

inline bool eo_cxx::elm::clock::edit_get() const
{
   Eina_Bool _tmp_ret;
   eo_do(_concrete_eo_ptr(), _tmp_ret = ::elm_obj_clock_edit_get());
   return ::efl::eolian::to_cxx<bool>(_tmp_ret, std::tuple<std::false_type>());
}

inline void eo_cxx::elm::clock::edit_set(bool edit_) const
{
   eo_do(_concrete_eo_ptr(), ::elm_obj_clock_edit_set(::efl::eolian::to_c(edit_)));
}

inline bool eo_cxx::elm::clock::pause_get() const
{
   Eina_Bool _tmp_ret;
   eo_do(_concrete_eo_ptr(), _tmp_ret = ::elm_obj_clock_pause_get());
   return ::efl::eolian::to_cxx<bool>(_tmp_ret, std::tuple<std::false_type>());
}

inline void eo_cxx::elm::clock::pause_set(bool paused_) const
{
   eo_do(_concrete_eo_ptr(), ::elm_obj_clock_pause_set(::efl::eolian::to_c(paused_)));
}

inline void eo_cxx::elm::clock::time_get(int* hrs_, int* min_, int* sec_) const
{
   eo_do(_concrete_eo_ptr(), ::elm_obj_clock_time_get(hrs_, min_, sec_));
}

inline void eo_cxx::elm::clock::time_set(int hrs_, int min_, int sec_) const
{
   eo_do(_concrete_eo_ptr(), ::elm_obj_clock_time_set(hrs_, min_, sec_));
}

inline Elm_Clock_Edit_Mode eo_cxx::elm::clock::edit_mode_get() const
{
   Elm_Clock_Edit_Mode _tmp_ret;
   eo_do(_concrete_eo_ptr(), _tmp_ret = ::elm_obj_clock_edit_mode_get());
   return _tmp_ret;
}

inline void eo_cxx::elm::clock::edit_mode_set(Elm_Clock_Edit_Mode digedit_) const
{
   eo_do(_concrete_eo_ptr(), ::elm_obj_clock_edit_mode_set(digedit_));
}

inline ::eo_cxx::elm::clock::operator ::elm::clock() const
{
   return *static_cast<::elm::clock const*>(static_cast<void const*>(this));
}

inline ::eo_cxx::elm::clock::operator ::elm::clock&()
{
   return *static_cast<::elm::clock*>(static_cast<void*>(this));
}

inline ::eo_cxx::elm::clock::operator ::elm::clock const&() const
{
   return *static_cast<::elm::clock const*>(static_cast<void const*>(this));
}

template <typename T>
bool elm_clock_show_am_pm_get_wrapper(Eo* objid EINA_UNUSED, ::efl::eo::detail::Inherit_Private_Data* self)
{
   try
      {
         return static_cast<T*>(self->this_)->show_am_pm_get();
      }
   catch (...)
      {
         eina_error_set( ::efl::eina::unknown_error() );
         Eina_Bool _tmp_ret{};
         return ::efl::eolian::to_cxx<bool>(_tmp_ret, std::tuple<std::false_type>());
      }
}

template <typename T>
void elm_clock_show_am_pm_set_wrapper(Eo* objid EINA_UNUSED, ::efl::eo::detail::Inherit_Private_Data* self, Eina_Bool am_pm_)
{
   try
      {
         static_cast<T*>(self->this_)->show_am_pm_set(::efl::eolian::to_cxx<bool>(am_pm_, std::tuple<std::false_type>()));
      }
   catch (...)
      {
         eina_error_set( ::efl::eina::unknown_error() );
      }
}

template <typename T>
double elm_clock_first_interval_get_wrapper(Eo* objid EINA_UNUSED, ::efl::eo::detail::Inherit_Private_Data* self)
{
   try
      {
         return static_cast<T*>(self->this_)->first_interval_get();
      }
   catch (...)
      {
         eina_error_set( ::efl::eina::unknown_error() );
         double _tmp_ret{};
         return _tmp_ret;
      }
}

template <typename T>
void elm_clock_first_interval_set_wrapper(Eo* objid EINA_UNUSED, ::efl::eo::detail::Inherit_Private_Data* self, double interval_)
{
   try
      {
         static_cast<T*>(self->this_)->first_interval_set(interval_);
      }
   catch (...)
      {
         eina_error_set( ::efl::eina::unknown_error() );
      }
}

template <typename T>
bool elm_clock_show_seconds_get_wrapper(Eo* objid EINA_UNUSED, ::efl::eo::detail::Inherit_Private_Data* self)
{
   try
      {
         return static_cast<T*>(self->this_)->show_seconds_get();
      }
   catch (...)
      {
         eina_error_set( ::efl::eina::unknown_error() );
         Eina_Bool _tmp_ret{};
         return ::efl::eolian::to_cxx<bool>(_tmp_ret, std::tuple<std::false_type>());
      }
}

template <typename T>
void elm_clock_show_seconds_set_wrapper(Eo* objid EINA_UNUSED, ::efl::eo::detail::Inherit_Private_Data* self, Eina_Bool seconds_)
{
   try
      {
         static_cast<T*>(self->this_)->show_seconds_set(::efl::eolian::to_cxx<bool>(seconds_, std::tuple<std::false_type>()));
      }
   catch (...)
      {
         eina_error_set( ::efl::eina::unknown_error() );
      }
}

template <typename T>
bool elm_clock_edit_get_wrapper(Eo* objid EINA_UNUSED, ::efl::eo::detail::Inherit_Private_Data* self)
{
   try
      {
         return static_cast<T*>(self->this_)->edit_get();
      }
   catch (...)
      {
         eina_error_set( ::efl::eina::unknown_error() );
         Eina_Bool _tmp_ret{};
         return ::efl::eolian::to_cxx<bool>(_tmp_ret, std::tuple<std::false_type>());
      }
}

template <typename T>
void elm_clock_edit_set_wrapper(Eo* objid EINA_UNUSED, ::efl::eo::detail::Inherit_Private_Data* self, Eina_Bool edit_)
{
   try
      {
         static_cast<T*>(self->this_)->edit_set(::efl::eolian::to_cxx<bool>(edit_, std::tuple<std::false_type>()));
      }
   catch (...)
      {
         eina_error_set( ::efl::eina::unknown_error() );
      }
}

template <typename T>
bool elm_clock_pause_get_wrapper(Eo* objid EINA_UNUSED, ::efl::eo::detail::Inherit_Private_Data* self)
{
   try
      {
         return static_cast<T*>(self->this_)->pause_get();
      }
   catch (...)
      {
         eina_error_set( ::efl::eina::unknown_error() );
         Eina_Bool _tmp_ret{};
         return ::efl::eolian::to_cxx<bool>(_tmp_ret, std::tuple<std::false_type>());
      }
}

template <typename T>
void elm_clock_pause_set_wrapper(Eo* objid EINA_UNUSED, ::efl::eo::detail::Inherit_Private_Data* self, Eina_Bool paused_)
{
   try
      {
         static_cast<T*>(self->this_)->pause_set(::efl::eolian::to_cxx<bool>(paused_, std::tuple<std::false_type>()));
      }
   catch (...)
      {
         eina_error_set( ::efl::eina::unknown_error() );
      }
}

template <typename T>
void elm_clock_time_get_wrapper(Eo* objid EINA_UNUSED, ::efl::eo::detail::Inherit_Private_Data* self, int* hrs_, int* min_, int* sec_)
{
   try
      {
         static_cast<T*>(self->this_)->time_get(hrs_, min_, sec_);
      }
   catch (...)
      {
         eina_error_set( ::efl::eina::unknown_error() );
      }
}

template <typename T>
void elm_clock_time_set_wrapper(Eo* objid EINA_UNUSED, ::efl::eo::detail::Inherit_Private_Data* self, int hrs_, int min_, int sec_)
{
   try
      {
         static_cast<T*>(self->this_)->time_set(hrs_, min_, sec_);
      }
   catch (...)
      {
         eina_error_set( ::efl::eina::unknown_error() );
      }
}

template <typename T>
Elm_Clock_Edit_Mode elm_clock_edit_mode_get_wrapper(Eo* objid EINA_UNUSED, ::efl::eo::detail::Inherit_Private_Data* self)
{
   try
      {
         return static_cast<T*>(self->this_)->edit_mode_get();
      }
   catch (...)
      {
         eina_error_set( ::efl::eina::unknown_error() );
         Elm_Clock_Edit_Mode _tmp_ret{};
         return _tmp_ret;
      }
}

template <typename T>
void elm_clock_edit_mode_set_wrapper(Eo* objid EINA_UNUSED, ::efl::eo::detail::Inherit_Private_Data* self, Elm_Clock_Edit_Mode digedit_)
{
   try
      {
         static_cast<T*>(self->this_)->edit_mode_set(digedit_);
      }
   catch (...)
      {
         eina_error_set( ::efl::eina::unknown_error() );
      }
}

namespace efl { namespace eo { namespace detail {

template<>
struct operations< ::elm::clock >
{
   template <typename T>
   struct type
         : virtual operations< ::elm::layout >::template type<T>
   {
      virtual bool show_am_pm_get()
      {
         Eina_Bool _tmp_ret = {};

         eo_do_super(dynamic_cast<T*>(this)->_eo_ptr(),
               dynamic_cast<T*>(this)->_eo_class(),
               _tmp_ret = ::elm_obj_clock_show_am_pm_get());
            return ::efl::eolian::to_cxx<bool>(_tmp_ret, std::tuple<std::false_type>());
      }

      virtual void show_am_pm_set(bool am_pm_)
      {

         eo_do_super(dynamic_cast<T*>(this)->_eo_ptr(),
               dynamic_cast<T*>(this)->_eo_class(),
               ::elm_obj_clock_show_am_pm_set(::efl::eolian::to_c(am_pm_)));
      }

      virtual double first_interval_get()
      {
         double _tmp_ret = {};

         eo_do_super(dynamic_cast<T*>(this)->_eo_ptr(),
               dynamic_cast<T*>(this)->_eo_class(),
               _tmp_ret = ::elm_obj_clock_first_interval_get());
            return _tmp_ret;
      }

      virtual void first_interval_set(double interval_)
      {

         eo_do_super(dynamic_cast<T*>(this)->_eo_ptr(),
               dynamic_cast<T*>(this)->_eo_class(),
               ::elm_obj_clock_first_interval_set(interval_));
      }

      virtual bool show_seconds_get()
      {
         Eina_Bool _tmp_ret = {};

         eo_do_super(dynamic_cast<T*>(this)->_eo_ptr(),
               dynamic_cast<T*>(this)->_eo_class(),
               _tmp_ret = ::elm_obj_clock_show_seconds_get());
            return ::efl::eolian::to_cxx<bool>(_tmp_ret, std::tuple<std::false_type>());
      }

      virtual void show_seconds_set(bool seconds_)
      {

         eo_do_super(dynamic_cast<T*>(this)->_eo_ptr(),
               dynamic_cast<T*>(this)->_eo_class(),
               ::elm_obj_clock_show_seconds_set(::efl::eolian::to_c(seconds_)));
      }

      virtual bool edit_get()
      {
         Eina_Bool _tmp_ret = {};

         eo_do_super(dynamic_cast<T*>(this)->_eo_ptr(),
               dynamic_cast<T*>(this)->_eo_class(),
               _tmp_ret = ::elm_obj_clock_edit_get());
            return ::efl::eolian::to_cxx<bool>(_tmp_ret, std::tuple<std::false_type>());
      }

      virtual void edit_set(bool edit_)
      {

         eo_do_super(dynamic_cast<T*>(this)->_eo_ptr(),
               dynamic_cast<T*>(this)->_eo_class(),
               ::elm_obj_clock_edit_set(::efl::eolian::to_c(edit_)));
      }

      virtual bool pause_get()
      {
         Eina_Bool _tmp_ret = {};

         eo_do_super(dynamic_cast<T*>(this)->_eo_ptr(),
               dynamic_cast<T*>(this)->_eo_class(),
               _tmp_ret = ::elm_obj_clock_pause_get());
            return ::efl::eolian::to_cxx<bool>(_tmp_ret, std::tuple<std::false_type>());
      }

      virtual void pause_set(bool paused_)
      {

         eo_do_super(dynamic_cast<T*>(this)->_eo_ptr(),
               dynamic_cast<T*>(this)->_eo_class(),
               ::elm_obj_clock_pause_set(::efl::eolian::to_c(paused_)));
      }

      virtual void time_get(int* hrs_, int* min_, int* sec_)
      {

         eo_do_super(dynamic_cast<T*>(this)->_eo_ptr(),
               dynamic_cast<T*>(this)->_eo_class(),
               ::elm_obj_clock_time_get(hrs_, min_, sec_));
      }

      virtual void time_set(int hrs_, int min_, int sec_)
      {

         eo_do_super(dynamic_cast<T*>(this)->_eo_ptr(),
               dynamic_cast<T*>(this)->_eo_class(),
               ::elm_obj_clock_time_set(hrs_, min_, sec_));
      }

      virtual Elm_Clock_Edit_Mode edit_mode_get()
      {
         Elm_Clock_Edit_Mode _tmp_ret = {};

         eo_do_super(dynamic_cast<T*>(this)->_eo_ptr(),
               dynamic_cast<T*>(this)->_eo_class(),
               _tmp_ret = ::elm_obj_clock_edit_mode_get());
            return _tmp_ret;
      }

      virtual void edit_mode_set(Elm_Clock_Edit_Mode digedit_)
      {

         eo_do_super(dynamic_cast<T*>(this)->_eo_ptr(),
               dynamic_cast<T*>(this)->_eo_class(),
               ::elm_obj_clock_edit_mode_set(digedit_));
      }

   };
};


template<>
struct operation_description_class_size< ::elm::clock >
{
   static constexpr int value = 
#if defined(CLOCK_PROTECTED) && defined(CLOCK_BETA)
      14
#elif defined(CLOCK_PROTECTED)
      14
#elif defined(CLOCK_BETA)
      14
#else
      14
#endif
      + operation_description_class_size<::elm::layout >::value;
};

template <typename T>
int initialize_operation_description(::efl::eo::detail::tag<::elm::clock>
                                 , Eo_Op_Description* ops)
{
   int i = 0;
   (void)i;
   (void)ops;
   ops[i].func = reinterpret_cast<void*>(& ::elm_clock_show_am_pm_get_wrapper<T>);
   ops[i].api_func = reinterpret_cast<void*>(& ::elm_obj_clock_show_am_pm_get);
   ops[i].op_type = EO_OP_TYPE_REGULAR;
   ++i;

   ops[i].func = reinterpret_cast<void*>(& ::elm_clock_show_am_pm_set_wrapper<T>);
   ops[i].api_func = reinterpret_cast<void*>(& ::elm_obj_clock_show_am_pm_set);
   ops[i].op_type = EO_OP_TYPE_REGULAR;
   ++i;

   ops[i].func = reinterpret_cast<void*>(& ::elm_clock_first_interval_get_wrapper<T>);
   ops[i].api_func = reinterpret_cast<void*>(& ::elm_obj_clock_first_interval_get);
   ops[i].op_type = EO_OP_TYPE_REGULAR;
   ++i;

   ops[i].func = reinterpret_cast<void*>(& ::elm_clock_first_interval_set_wrapper<T>);
   ops[i].api_func = reinterpret_cast<void*>(& ::elm_obj_clock_first_interval_set);
   ops[i].op_type = EO_OP_TYPE_REGULAR;
   ++i;

   ops[i].func = reinterpret_cast<void*>(& ::elm_clock_show_seconds_get_wrapper<T>);
   ops[i].api_func = reinterpret_cast<void*>(& ::elm_obj_clock_show_seconds_get);
   ops[i].op_type = EO_OP_TYPE_REGULAR;
   ++i;

   ops[i].func = reinterpret_cast<void*>(& ::elm_clock_show_seconds_set_wrapper<T>);
   ops[i].api_func = reinterpret_cast<void*>(& ::elm_obj_clock_show_seconds_set);
   ops[i].op_type = EO_OP_TYPE_REGULAR;
   ++i;

   ops[i].func = reinterpret_cast<void*>(& ::elm_clock_edit_get_wrapper<T>);
   ops[i].api_func = reinterpret_cast<void*>(& ::elm_obj_clock_edit_get);
   ops[i].op_type = EO_OP_TYPE_REGULAR;
   ++i;

   ops[i].func = reinterpret_cast<void*>(& ::elm_clock_edit_set_wrapper<T>);
   ops[i].api_func = reinterpret_cast<void*>(& ::elm_obj_clock_edit_set);
   ops[i].op_type = EO_OP_TYPE_REGULAR;
   ++i;

   ops[i].func = reinterpret_cast<void*>(& ::elm_clock_pause_get_wrapper<T>);
   ops[i].api_func = reinterpret_cast<void*>(& ::elm_obj_clock_pause_get);
   ops[i].op_type = EO_OP_TYPE_REGULAR;
   ++i;

   ops[i].func = reinterpret_cast<void*>(& ::elm_clock_pause_set_wrapper<T>);
   ops[i].api_func = reinterpret_cast<void*>(& ::elm_obj_clock_pause_set);
   ops[i].op_type = EO_OP_TYPE_REGULAR;
   ++i;

   ops[i].func = reinterpret_cast<void*>(& ::elm_clock_time_get_wrapper<T>);
   ops[i].api_func = reinterpret_cast<void*>(& ::elm_obj_clock_time_get);
   ops[i].op_type = EO_OP_TYPE_REGULAR;
   ++i;

   ops[i].func = reinterpret_cast<void*>(& ::elm_clock_time_set_wrapper<T>);
   ops[i].api_func = reinterpret_cast<void*>(& ::elm_obj_clock_time_set);
   ops[i].op_type = EO_OP_TYPE_REGULAR;
   ++i;

   ops[i].func = reinterpret_cast<void*>(& ::elm_clock_edit_mode_get_wrapper<T>);
   ops[i].api_func = reinterpret_cast<void*>(& ::elm_obj_clock_edit_mode_get);
   ops[i].op_type = EO_OP_TYPE_REGULAR;
   ++i;

   ops[i].func = reinterpret_cast<void*>(& ::elm_clock_edit_mode_set_wrapper<T>);
   ops[i].api_func = reinterpret_cast<void*>(& ::elm_obj_clock_edit_mode_set);
   ops[i].op_type = EO_OP_TYPE_REGULAR;
   ++i;

   initialize_operation_description<T>(::efl::eo::detail::tag<::elm::layout>(), &ops[operation_description_class_size< ::elm::clock >::value]);
   return 0;
}
inline Eo_Class const* get_eo_class(tag<::elm::clock>)
{
   return (ELM_CLOCK_CLASS);
}

} } }

/// @endcond

